/******************************************************************************
 *
 *      Checkers v2.2 (c) David A.S.Crofts
 *
 *      23 Brisbane Street
 *      Berwick Victoria 3806
 *      Australia
 *
 *      email: dasc1961@netscape.net
 *
 *****************************************************************************/

#ifndef __CHECKERS_H__
#define __CHECKERS_H__

#include <PalmTypes.h>


/***********************************************************************
 *
 *      Internal Constants
 *
 ***********************************************************************/

#define  checkersAppVersionNum          0x0101
#define  checkersAppCreator             'chec'

#define  version20                      0x02000000


#define  STALEMATE_LEGAL  false


#define  MAX_STATES       32

#define  PLAYER_PIECE     0
#define  PLAYER_KING      1
#define  COMPUTER_PIECE   2
#define  COMPUTER_KING    3
#define  NO_PIECE         4

#define  HIGHEST_VALID_PIECE         4

#define  HI_LIGHTED_PLAYER_PIECE     5
#define  HI_LIGHTED_PLAYER_KING      6
#define  HI_LIGHTED_NO_PIECE         7
#define  HI_LIGHTED_END_SQUARE       8
#define  HI_LIGHTED_MID_SQUARE       9

#define COMPUTER_START_SQUARE       10
#define COMPUTER_END_SQUARE_PIECE   11
#define COMPUTER_END_SQUARE_KING    12
#define COMPUTER_JUMPED_SQUARE      13


#ifndef  TRUE
#define  TRUE           1
#endif

#ifndef  FALSE
#define  FALSE          0
#endif

#ifndef  NULL
#define  NULL           0L
#endif


/***********************************************************************
 *
 *      Internal Structures
 *
 ***********************************************************************/

typedef struct state_block
{

    UInt8 board[32];
    Int32 piece;
    Int16 turn;
    
    Int32 value;
    Boolean draw;
    Boolean game_over;

    struct state_block *memPtr;
    MemHandle memHandle;

}
STATE, *STATE_PTR;


typedef struct sucessor_block
{

    UInt16 num;
    STATE_PTR ptr[MAX_STATES];

    struct sucessor_block *memPtr;
    MemHandle memHandle;

}
SUCESSOR, *SUCESSOR_PTR;


typedef struct piece_block
{

    UInt16 mover_piece;
    UInt16 mover_king;
    UInt16 oponent_piece;
    UInt16 oponent_king;

}
PIECE_NOS, *PIECE_NOS_PTR;


typedef struct PieceCoordType
{

    Int16 row;
    Int16 col;

}
PieceCoordType;


typedef enum GameStateType
{

    gameInProgress,
    gameWon,
    gameLost

}
GameStateType;


typedef struct GameType
{

    GameStateType state;
    Boolean restored;
    Boolean draw;
    Boolean first_move;
    Boolean game_over;
    Boolean player_jump_found;
    Boolean compulsory_jump_found;
    UInt8 default_piece;
    Int16 compulsory_jump_start_square;
    Int16 new_square[64];
    Int16 square[64];
    Int16 old_square[64];
    Int32 value;
    Int16 depth;
    Int16 temp_depth;

}
GameType;


typedef struct CheckersPrefType
{

    UInt32 signature;
    GameType game;

}
CheckersPrefType;


#define CheckersPrefSignature   'ChEc'


#endif // __CHECKERS_H__
